Groovy Documentation

## org.codehaus.groovy.transform
[Java] Class CategoryASTTransformation

    java.lang.Object
      org.codehaus.groovy.transform.CategoryASTTransformation

All Implemented Interfaces:
  ASTTransformation, org.objectweb.asm.Opcodes

    @GroovyASTTransformation(phase = CompilePhase.CANONICALIZATION)
    public class CategoryASTTransformation
    extends java.lang.Object

Handles generation of code for the

Category:
  annotation.

  Transformation logic is as follows:
  - all non-static methods converted to static ones with an additional 'self' parameter
  - references to 'this' changed to the additional 'self' parameter

Authors:
  Alex Tkachman

Method Summary
`void` | `visit(ASTNode[] nodes, SourceUnit source)` Property invocations done on 'this' reference are transformed so that the invocations at runtime are done on the additional parameter 'self'

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Method Detail

### visit

    public void visit(ASTNode[] nodes, SourceUnit source)

  Property invocations done on 'this' reference are transformed so that the invocations at runtime are done on the additional parameter 'self'

Groovy Documentation